/*
Copyright (c) 1994, The Regents of the University of Colorado

Permission to use, copy, modify, distribute, and sell this software and
its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of the University of
Colorado not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.  The University of Colorado makes no representations about
the suitability of this software for any purpose.  It is provided "as
is" without express or implied warranty.

The University of Colorado disclaims all warranties with regard to this
software, including all implied warranties of merchantability and
fitness, in no event shall the University of Colorado be liable for any
special, indirect or consequential damages or any damages whatsoever
resulting from loss of use, data or profits, whether in an action of
contract, negligence or other tortious action, arising out of or in
connection with the use or performance of this software.
*/

#define	SUCCESS	0
#define	FAILURE	-1

int Transform(pt,mtx,tpt,rotate_only)
  float	*pt;		/* ptr to point to transform (1x3 flt arry) */
  float	mtx[4][4];	/* ptr to transformation mtx (4x4 flt arry) */
  float	*tpt;		/* ptr to transformed point (1x3 flt arry) */
  short	rotate_only;	/* T/F: only perform rotation (no translation) */
{
float	a[4],b[4];
short	i,j,index;

if (rotate_only) index = 3;
else index = 4;

for (i = 0; i < 3; a[i] = pt[i++]);
a[3] = 1.0;
for (i = 0; i < 4; b[i++] = 0.0);

for (i = 0; i < index; i++)
  for (j = 0; j < index; j++)
    b[i] = b[i] + (a[j]*mtx[i][j]);

for (i = 0; i < 3; tpt[i] = b[i++]);

return(SUCCESS);
}
